#define MIDIMSG2(stat, data1) (DWORD)((stat) | ((data1) << 8))
#define MIDIMSG3(stat, data1, data2) (DWORD)((stat) | ((data1) << 8) | ((data2) << 16))

#define VOICE_FM	0
#define VOICE_PCM	1

typedef struct
{
	BYTE bm;
	BYTE bl;
	BYTE pc;

	// member for drum: normal must set 0 to these
	BYTE mapnote;
	BYTE drumnote;

	BYTE lfo;
	BYTE pan;
	BOOL pe;
	BYTE alg;	// only FM

	// extended member
	UINT type;

	// member for PCM
	DWORD fs;
	BOOL rm;
	BYTE wavno;
	DWORD lp;
	DWORD ep;
}CHPARAM;

typedef struct
{
				// max val
	BYTE multi;	//15	; only FM
	BYTE dt;	//7		; only FM
	BYTE ar;	//15
	BYTE dr;	//15
	BYTE sr;	//15
	BYTE rr;	//15
	BYTE sl;	//15
	BYTE tl;	//63
	BYTE ksl;	//3		; only FM
	BYTE dam;	//3
	BYTE dvb;	//3
	BYTE fb;	//7		; only FM
	BYTE ws;	//31	; only FM

	BOOL xof;
	BOOL sus;
	BOOL ksr;	//		; only FM
	BOOL eam;
	BOOL evb;
}OPPARAM;

typedef struct
{
	TCHAR name[17];	// 16 + NULL

	CHPARAM chp;
	OPPARAM opp[4];
}VOICE;

// to detail.c
extern COLORREF trackcolors[16];
